<?php

namespace Drupal\cmlmigrations\Service;

use Drupal\cmlapi\Service\SchemeInterface;
use Drupal\Core\Config\ConfigFactoryInterface;
#use Drupal\cmlmigrations\Utility\External;

/**
 * InitMigrations.
 */
class SchemeFields {

  /**
   * Config factory.
   *
   * @var \Drupal\Core\Config\ConfigFactoryInterface
   */
  protected $configFactory;

  /**
   * Creates a new Pileline manager.
   *
   * @param \Drupal\Core\Config\ConfigFactoryInterface $config_factory
   *   The config factory.
   * @param \Drupal\cmlapi\Service\SchemeInterface $cml_scheme
   *   The cml service.
   */
  public function __construct(
      ConfigFactoryInterface $config_factory,
      SchemeInterface $cml_scheme
    ) {
    // $this->cmlScheme = $cml_scheme;
    // $this->configFactory = $config_factory;
    // $this->extetnal = new External();
  }

  /**
   * Init.
   */
  public function exec($source) {
    // $source = \Drupal::service('cmlmigrations.scheme')->productTypes();
    // $this->createProps($source, FALSE);
    // return TRUE;
  }

  /**
   * Create Props.
   */
  public function createProps($source, $exec = FALSE) {
    // $this->exec = $exec;
    // foreach ($source as $pid => $product) {
    //   if (!isset($product['props'])) {
    //     continue;
    //   }
    //   $bundle = $product['machine'];
    //   foreach ($product['props'] as $key => $field) {
    //     $set = $this->fieldSet($field);
    //     // $this->createVariation();
    //     $this->createFieldStorage($field, $set);
    //     $this->createFieldInstance($field, $set, $bundle);
    //   }
    // }
  }

  /**
   * Map_cml_scheme_vocabulary.
   */
  private function volcabMap($key) {
    // $map = &drupal_static('CmlMigrations::SchemeProduct::map()');
    // if (!isset($map)) {
    //   $map = [];
    //   $query = \Drupal::database()
    //     ->select('migrate_map_cml_scheme_vocabulary', 'map')
    //     ->fields('map', ['sourceid1', 'destid1']);
    //   foreach ($query->execute()->fetchAll() as $val) {
    //     $map[$val->sourceid1] = $val->destid1;
    //   }
    // }
    // $volcab = $map[$key];
    // return [
    //   $volcab => $volcab,
    // ];
  }

  /**
   * Field Settings.
   */
  private function fieldSet($field) {
    //
    // switch ($field['type']) {
    //   case 'Float':
    //     $set = [
    //       'type' => 'float',
    //       'form' => 'number',
    //       'display' => 'number_decimal',
    //       'settings' => [],
    //       'storage' => [],
    //     ];
    //     break;
    //
    //   case 'Int':
    //     $set = [
    //       'type' => 'integer',
    //       'form' => 'number',
    //       'display' => 'number_decimal',
    //       'settings' => [],
    //       'storage' => [],
    //     ];
    //     break;
    //
    //   case 'Select':
    //     $target_bundles = $this->volcabMap($field['uuid1c']);
    //     $set = [
    //       'type' => 'entity_reference',
    //       'form' => 'entity_reference_autocomplete',
    //       'display' => 'entity_reference_label',
    //       'settings' => [
    //         "handler" => 'default',
    //         "handler_settings" => [
    //           "target_bundles" => $target_bundles,
    //         ],
    //       ],
    //       'storage' => [
    //         "target_type" => 'taxonomy_term',
    //         "handler_settings" => [
    //           "target_bundles" => $target_bundles,
    //         ],
    //       ],
    //     ];
    //     break;
    //
    //   default:
    //     $set = [
    //       'type' => 'string',
    //       'form' => 'string_textfield',
    //       'display' => 'string',
    //       'settings' => [],
    //       'storage' => [
    //         'max_length' => 255,
    //         'is_ascii' => FALSE,
    //         'case_sensitive' => FALSE,
    //       ],
    //     ];
    //     break;
    // }
    // $set['cardinality'] = 1;
    // if (FALSE) {
    //   // FieldStorageDefinitionInterface::CARDINALITY_UNLIMITED //.
    //   $set['cardinality'] = -1;
    // }
    // return $set;
  }

  /**
   * Create Variation.
   */
  private function createVariation($field) {
    // $attribute = ProductAttribute::create([
    //   'id' => $field['machine'],
    //   'label' => $field['name'],
    // ]);
    // $attribute->save();
    // $fieldManager = \Drupal::service('commerce_product.attribute_field_manager');
    // $fieldManager->createField($attribute, "default");
    // $attr = FieldConfig::loadByName('commerce_product_variation', "default", "attribute_{$field['machine']}");
    // $attr->setRequired(FALSE)->save();
    // $this->setVariationOption($field['machine'], $field['props']);
  }

  /**
   * Create Field Storage.
   */
  private function createFieldStorage($field, $set) {
    // $field_storage = [
    //   'type' => $set['type'],
    //   'field_name' => $field['machine'],
    //   'entity_type' => 'commerce_product',
    //   'cardinality' => $set['cardinality'],
    //   'module' => 'core',
    //   'locked' => FALSE,
    //   'settings' => $set['storage'],
    // ];
    // if ($this->exec) {
    //   FieldStorageConfig::create($field_storage)->save();
    // }
  }

  /**
   * Create Field Instance.
   */
  private function createFieldInstance($field, $set, $bundle) {
    // $field_instance = [
    //   'label' => $field['name'],
    //   'bundle' => $bundle,
    //   'field_name' => $field['machine'],
    //   'entity_type' => 'commerce_product',
    //   'required' => FALSE,
    //   'settings' => $set['settings'],
    // ];
    // if ($this->exec) {
    //   FieldConfig::create($field_instance)->save();
    //
    //   entity_get_form_display('commerce_product', 'default', 'default')
    //     ->setComponent($field_instance['field_name'], [
    //       'type' => $set['form'],
    //     ])
    //     ->save();
    //   // $display = \Drupal::entityTypeManager()
    //   // ->getStorage('entity_view_display')
    //   // ->load('commerce_product.default.default');
    //   entity_get_display('commerce_product', 'default', 'default')
    //     ->setComponent($field_instance['field_name'], [
    //       'label' => 'inline',
    //       'type' => $set['display'],
    //       'settings' => ["link" => FALSE],
    //     ])
    //     ->save();
    // }
  }

}
